# README #

### What is this repository for? ###

* Overview

This repository contains instructions to setup a base cdn service for the D4Science platform
  
* Version

0.0.1

### How do I get set up? ###

* Summary of set up

This repository contains all information to build a D4S cdn image. Most importantly it contains the ansible instructions to deploy a swarm containing ROUTER, CDN base service and PEP.

* Deployment instructions

There are 4 branches.

__main__ branch contains configurations to start a local instance useful for development. It is configured to use the D4SCience dev IAM.

__dev__ branch contains the configuration to run on D4Science Docker swarm cluster acting on the DEV infrastructure. 

__pre__ branch contains the configuration to run on D4Science Docker swarm cluster acting on the PRE infrastructure. 

__prod__ branch contains the configuration to run on D4Science Docker swarm cluster acting on the PROD infrastructure.

In order to run a local site the following commands need to be executed:

```
git clone https://code-repo.d4science.org/gCubeSystem/d4s-cdn-setup.git
ansible-playbook site.yaml --ask-vault-pass
```
This will create a basic stack with an NGINX based router, a PEP and base CDN service.

If you want to deploy on a specific D4S infrastructure please clone the corresponding branch.

```
git clone -b {infra} https://code-repo.d4science.org/gCubeSystem/d4s-cdn-setup.git
ansible-playbook site.yaml --ask-vault-pass
```

### Contribution guidelines ###

* Adding a new CDN Island

* Commit guidelines

DO NOT commit the following files:

conf/pep/config.js
conf/service/auth.js

They will be generated by the ansible based deployment procedure in order to inject the secrets.

### Who do I talk to? ###

* Repo owner or admin

Marco Lettere
marco.lettere@nubisware.com

